#include <curses.h>
#include <panel.h>
#include "config.h"
#include <stdlib.h>

int total_access;
int total_sbyte;
int total_rbyte;
int total_time, on_usr_cnt;
char online_str[MAXPORTS][256], online_usr[MAXPORTS][24];
WINDOW *userwin, *infowin, *portwin, *waitwin, *status;
WINDOW *userborder, *infoborder, *portborder;
usrsum sums[MAXUSERS];

/*	The following routines print the helpers at the bottom of the
	screen, depending on which window is active.
*/

void	user_menu()
{
	wmove(status, 0, 0);
 	waddch(status, ACS_LLCORNER);
	wmove(status, 0, 79);
 	waddch(status, ACS_LRCORNER);
	wmove(status, 0, 1);
	whline(status, ACS_HLINE, 78); 	
	wmove(status, 0,1);
	waddstr(status, "<UP/DN>");
	wmove(status, 0, 9);
	waddstr(status, "<ENTER View User Log>");
	wmove(status, 0, 31);
	waddstr(status, "<'P'ort Win>");
	wmove(status, 0, 44);
	waddstr(status, "<'F'ind User>");
	wmove(status, 0, 58);
	waddstr(status, "<ESC Exit>");
	wrefresh(status);	
}

void	info_menu()
{
	wmove(status, 0, 0);
 	waddch(status, ACS_LLCORNER);
	wmove(status, 0, 79);
 	waddch(status, ACS_LRCORNER);
	wmove(status, 0, 1);
	whline(status, ACS_HLINE, 78); 	
	wmove(status, 0,1);
	waddstr(status, "<UP/DN Scroll Window>");
	wmove(status, 0, 23);
	waddstr(status, "<ESC Back To User Window>");
	wrefresh(status);	
}


void	port_menu()
{
	wmove(status, 0, 0);
 	waddch(status, ACS_LLCORNER);
	wmove(status, 0, 79);
 	waddch(status, ACS_LRCORNER);
	wmove(status, 0, 1);
	whline(status, ACS_HLINE, 78); 	
	wmove(status, 0,1);
	waddstr(status, "<UP/DN Scroll Window>");
	wmove(status, 0, 23);
	waddstr(status, "<'X' To Disconnect User>");
	wmove(status, 0, 48);
	waddstr(status, "<ESC Return To User Window>");
	wrefresh(status);	
}

/*	The function main_win() draws the desktop and initializes
	various window attributes and defaults.
*/

void	main_win(char month[3])
{
	char PPPSTR[] = "pppParse";
	WINDOW *border;
	int i;

	initscr();
	nonl();
	cbreak();
	noecho();

	border = newwin(25, 80, 0, 0);
	box(border, ACS_VLINE, ACS_HLINE);
	wmove(border, 0,1);
	waddstr(border, PPPSTR);
	wmove(border, 0, 30);
	wprintw(border, "Active Month: %s", month);
	wrefresh(border);	

	status = newwin(1, 80, 24, 0);

	user_menu();

	userborder = newwin(15, 12, 1, 1);
	box(userborder, ACS_VLINE, ACS_HLINE);
	wmove(userborder, 0,1);
	waddstr(userborder, "User");
	wrefresh(userborder);	

	infoborder = newwin(15, 65, 1, 14);
	box(infoborder, ACS_VLINE, ACS_HLINE);
	wmove(infoborder, 0,1);
	waddstr(infoborder, "Date/Time");
	wmove(infoborder, 0,21);
	waddstr(infoborder, "Minutes");
	wmove(infoborder, 0,33);
	waddstr(infoborder, "Bytes Sent");
	wmove(infoborder, 0,49);
	waddstr(infoborder, "Bytes Recieved");
	wrefresh(infoborder);	

	portborder = newwin(8, 78, 16, 1);
	box(portborder, ACS_VLINE, ACS_HLINE);
	wmove(portborder, 0,1);
	waddstr(portborder, "Active User");
	wmove(portborder, 0,17);
	waddstr(portborder, "Date/Time");
	wmove(portborder, 0,36);
	waddstr(portborder, "Interface");
	wmove(portborder, 0,49);
	waddstr(portborder, "Port");
	wmove(portborder, 0,70);
	waddstr(portborder, "PID");
	wrefresh(portborder);	

	userwin = newwin(13, 10, 2, 2);
	infowin = newwin(13, 63, 2, 15);
	portwin = newwin(6, 76, 17, 2);
	scrollok(userwin, 1);
	scrollok(infowin, 1);
	scrollok(portwin, 1);
	waitwin = newwin(6, 35, 5, 20);

	keypad(userwin, 1);
	meta(userwin, 1);
	wtimeout(userwin, -1);
	notimeout(userwin, 0);

	keypad(infowin, 1);
	meta(infowin, 1);
	wtimeout(infowin, -1);
	notimeout(infowin, 0);

	keypad(portwin, 1);
	meta(portwin, 1);
	wtimeout(portwin, -1);
	notimeout(portwin, 0);
}

/*	The function i_win() outputs the global usage statistics. 
*/

void	i_win(int num_user)
{
	werase(infowin);
	wmove(infowin, 0, 0);
	wprintw(infowin, "\n\n\tTotal Usage Statistics (All Users):\n");
	wprintw(infowin, "\n\tTotal Number of Users: %d\n", num_user - 1);
	wprintw(infowin, "\tTotal Number of Log-Ins: %d\n", total_access);
	wprintw(infowin,"\tTotal Time Online (All Users): %d Minutes\n",total_time);
	wprintw(infowin, "\tTotal Bytes Sent (By Users): %d\n", total_sbyte);
	wprintw(infowin, "\tTotal Bytes Received (By Users): %d", total_rbyte);
}

/*	The function user_show() outputs the usage statistics summary
	for the currently highlighted user.  it is only caled by the
	function u_win().
*/

void	user_show(char usr_name[25], int i, int nusers)
{
	if(!strcmp(usr_name, "All Users"))
	{
		i_win(nusers);
		return;
	}

	werase(infowin);
	wmove(infowin, 0, 3);
	wprintw(infowin, "\n\n\tTotal Usage Statistics For %s:\n\n", usr_name);
	wprintw(infowin,"\tTotal Number of Log-Ins: %d\n",sums[i].access_count);
	wprintw(infowin,"\tTotal Time Online: %d Minutes\n",sums[i].online_count);
	wprintw(infowin,"\tTotal Bytes Sent (By User): %d\n",sums[i].sbyte_count);
	wprintw(infowin,"\tTotal Bytes Received (By User): %d\n",sums[i].rbyte_count);
}

/*	The function info_win() displays and scrolls through the usage
	log for a user if the ENTER key is pressed.  It is only called
	by the function u_win().
*/

void	info_win(int nlines, usrall *usr,int usr_place)
{
   int i, info_place=0, quit = 0;


   wmove(infowin, 0, 0);

   info_menu();
   wrefresh(status);
   while(!quit)
   {	
	switch(wgetch(infowin))
	{
  	  case 27:
		quit = 1;
		break;
	  case KEY_UP:
	  {
		if(info_place)
	 	{	
		   wscrl(infowin, -1);
		   wmove(infowin, 0, 0);
	 	   wprintw(infowin, "%s", usr->info[info_place]);	
		   info_place -= 1;
		   wmove(infowin, usr_place, 0);
		   break;
		}
		else
			break;	
	  }	
	  case KEY_DOWN:
	  {
		if(info_place < nlines - 13)
	 	{	
		   wscrl(infowin, 1);
		   wmove(infowin, 12, 0);
	 	   wprintw(infowin, "%s", usr->info[info_place+14]);	
		   info_place += 1;
		   wmove(infowin, usr_place, 0);
		   break;
		}
		else
			break;	
	  }	
	}
   }
}

/*	The function port_show() shows an active port/user line in
	the port window.
*/

void	port_show(char onusr[], char onstr[])
{
	char iface[10], port[25], dpid[10], dtime[16];

/*	if the port has previously been disconnected by pppParse, 
	display the Disconnected line, otherwise, show the port
	information contained in the global variable onstr[].
*/

	if(!strcmp(onstr, "Disconnected"))
	{
		wprintw(portwin,"%s\t\t%s", onusr, onstr);
		wrefresh(portwin);
	}
	else
	{
		strncpy(dtime, onstr, 15);
		dtime[15] = '\0';
		get_name(onstr,"Connect:", 9,' ', iface);
		get_name(onstr, "<-->", 5, '\n', port);
		get_name(onstr, "pppd", 5, ']', dpid);
		wprintw(portwin,"%s\t\t%s\t   %s\t\t%s\t     %s"
		,onusr, dtime, iface, port, dpid);
		wrefresh(portwin);
	}
}

/*	The function p_win() displays, scrolls through and can
	disconnect active ports (if any).  If the variable is
	zero, the ports are just listed (i.e., for an initial
	display of the ports at start up).  Otherwise, the 
	port window is made active and the full routine is 
	implemented.
*/

void   p_win(int port_count, char on_user[MAXPORTS][24],
		char onstr[MAXPORTS][256], int active)
{
    int i=0, port_place=0, cursor_place=0, quit=0;
    char dtime[16], iface[25], port[25], dpid[10], tmp_str[256], ch;
    char kill_cmd[50], tmp_char;
    FILE *killfile;
    WINDOW *msgwin;

/*	Show all active ports.
*/

    while(i < port_count && i < 6)
    {
	wmove(portwin, i, 0);
	port_show(on_user[i], onstr[i]);
	i++;
    }
    wrefresh(portwin);

/*	If the function is called as active, make port window
	active and accept input in the port window.
*/

    if(active)
    {
	port_menu();
	wrefresh(status);
	wmove(portwin, 0, 0);	
	wattrset(portwin, A_REVERSE);
	port_show(on_user[0], onstr[0]);
	while(!quit)
 	{	
	   switch(wgetch(portwin))
	   {
  	  	case 27:
			quit = 1;
			break;
/*	If the 'x' key is pressed, try to disconnect the port
	by killing it's PID.  Only a superuser can do this.  See
	config.h to change the default kill command.
*/

		case 'x':
		case 'X':
		{
			if(!strcmp(onstr[port_place], "Disconnected"))
				break;
			get_name(onstr[port_place], "pppd", 5, ']', dpid);
			strcpy(kill_cmd, KILLCMD);
			strcat(kill_cmd, dpid);
			strcat(kill_cmd, " 2> /dev/stdout");	
			
			if((killfile = popen(kill_cmd, "r")) == NULL)
			{	
				endwin();
				printf("Can't Run Kill Command.  Exiting.\n");
				exit(0);
			}
			tmp_char = fgetc(killfile);

/*	If the kill was successful, there should be no output to 
	stdout ot stderr.  Otherwise, show an error message.
*/

			if(!feof(killfile))
			{
	  			ch = 0;
				msgwin=newwin(4, 25, 11, 25);
				box(msgwin, ACS_VLINE, ACS_HLINE);	
				wmove(msgwin, 1, 2);
				waddstr(msgwin, "Can't Kill Process");	
				wmove(msgwin, 2, 2);
				waddstr(msgwin, "Hit Any Key");	
				wrefresh(msgwin);
				while (!ch)
				{
			   		ch = wgetch(msgwin);
			   		if(ch)
				  		break;
				}	
				werase(msgwin);
				wrefresh(msgwin);
				wrefresh(infowin);	
				delwin(msgwin);
			}
			else
			{
			   strcpy(onstr[port_place], "Disconnected");
			   wattrset(portwin, A_NORMAL);
			   werase(portwin); 
			   wattrset(portwin, A_REVERSE);
			   wmove(portwin, 0, 0);
			   wprintw(portwin,"%s\t\t%s", on_user[port_place],
					onstr[port_place]);
			}
			
			pclose(killfile);
			break;	
		}
	        case KEY_UP:
	        {
			if(port_place && !cursor_place)
		 	{	
			   wmove(portwin, cursor_place, 0);	
			   wattrset(portwin, A_NORMAL);
			   port_show(on_user[port_place], onstr[port_place]);
			   wscrl(portwin, -1);
			   port_place -= 1;
			   wmove(portwin, cursor_place, 0);	
			   wattrset(portwin, A_REVERSE);
			   port_show(on_user[port_place], onstr[port_place]);
			   wmove(portwin, cursor_place, 0);	
			   break;
			}	
			else if(cursor_place && port_place)
		 	{	
			   wattrset(portwin, A_NORMAL);
			   wmove(portwin, cursor_place, 0);
			   port_show(on_user[port_place], onstr[port_place]);
			   cursor_place -= 1;
			   wmove(portwin, cursor_place, 0);
			   port_place -= 1;
			   wattrset(portwin, A_REVERSE);
			   port_show(on_user[port_place], onstr[port_place]);
			   wmove(portwin, cursor_place, 0);	
			   break;
			}
			else
				break;	
		   }
	        case KEY_DOWN:
		{
			if((port_place < (port_count-1)) && (cursor_place == 5))
		 	{	
			   wattrset(portwin, A_NORMAL);
			   port_show(on_user[port_place], onstr[port_place]);
			   wscrl(portwin, 1);
			   port_place += 1;
			   wmove(portwin, 5, 0);
			   wattrset(portwin, A_REVERSE);
			   port_show(on_user[port_place], onstr[port_place]);
			   wmove(portwin, cursor_place, 0);
			   wrefresh(portwin);
			   break;
			}	
			else if(cursor_place < 5 && port_place <(port_count-1)) 
		 	{	
			   wmove(portwin, cursor_place, 0);
			   wattrset(portwin, A_NORMAL);
			   port_show(on_user[port_place], onstr[port_place]);
			   cursor_place += 1;
			   wmove(portwin, cursor_place, 0);
			   port_place += 1;
			   wattrset(portwin, A_REVERSE);
			   port_show(on_user[port_place], onstr[port_place]);
			   wrefresh(portwin);
			   wmove(portwin, cursor_place, 0);
			   endwin();	
			}
			else
				break;
	  	 }	
	   }

	}
	wmove(portwin, cursor_place, 0);	
	wattrset(portwin, A_NORMAL);
	port_show(on_user[port_place], onstr[port_place]);
	wrefresh(portwin);
   }
}

/*	The function u_win() displays, scrolls through and can
	calls other functions related to users.  If the variable 
	active is zero, the users are just listed (i.e., for an 
	initial	display of users at start up).  Otherwise, the 
	user window is made active and the full routine is 
	implemented.
*/

void	u_win(int nusers,char usrname[MAXUSERS][25], FILE *log, int active,
	char month[], char onusr[MAXPORTS][24], 
	char onstr[MAXPORTS][256], int port_count)
{
	int i, j, quit = 0, user_place, cursor_place, n_lines, found=0;
	usrall usr;
	WINDOW *findwin, *msgwin;
	char find_name[25], ch;
	
	for(i=0; (i<nusers && i<13); i++)
	{
	   wmove(userwin, i, 0);
	   waddnstr(userwin, usrname[i], 9);
	}

	if(active)
	{
	   wmove(userwin, 0, 0);
	   wattrset(userwin, A_REVERSE);
	   waddnstr(userwin, usrname[0], 9);	
	   wattrset(userwin, A_NORMAL);
	   
 	   wmove(userborder, 14, 1);
 	   waddstr(userborder, "<ACTIVE>");
	   wrefresh(userborder);	
	  
	   user_place = 0;
	   cursor_place = 0;
		
	   while(!quit)
	   {	
		
		wrefresh(infowin);	
		wmove(userwin, cursor_place, 0);	
		switch (wgetch(userwin))
		{	
		   case 27:
			quit = 1;
			break;
		   case KEY_UP:
		   {
			if(user_place && !cursor_place)
		 	{	
			   wmove(userwin, cursor_place, 0);	
			   wattrset(userwin, A_NORMAL);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wscrl(userwin, -1);
			   user_place -= 1;
			   wmove(userwin, cursor_place, 0);	
			   wattrset(userwin, A_REVERSE);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wmove(userwin, cursor_place, 0);	
			   user_show(usrname[user_place], user_place, nusers);
			   break;
			}	
			else if(cursor_place && user_place)
		 	{	
			   wattrset(userwin, A_NORMAL);
			   wmove(userwin, cursor_place, 0);
			   waddnstr(userwin, usrname[user_place], 9);	
			   cursor_place -= 1;
			   wmove(userwin, cursor_place, 0);
			   user_place -= 1;
			   wattrset(userwin, A_REVERSE);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wmove(userwin, cursor_place, 0);	
			   user_show(usrname[user_place], user_place, nusers);
			   break;
			}
			else
				break;	
		   }
		   case KEY_DOWN:
		   {
			if((user_place < (nusers-1)) && (cursor_place == 12))
		 	{	
			   wattrset(userwin, A_NORMAL);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wscrl(userwin, 1);
			   user_place += 1;
			   wmove(userwin, 12, 0);
			   wattrset(userwin, A_REVERSE);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wmove(userwin, cursor_place, 0);
			   user_show(usrname[user_place], user_place, nusers);
			   break;
			}	
			else if(cursor_place < 12 && user_place < (nusers-1)) 
		 	{	
			   wmove(userwin, cursor_place, 0);
			   wattrset(userwin, A_NORMAL);
			   waddnstr(userwin, usrname[user_place], 9);	
			   cursor_place += 1;
			   wmove(userwin, cursor_place, 0);
			   user_place += 1;
			   wattrset(userwin, A_REVERSE);
			   waddnstr(userwin, usrname[user_place], 9);	
			   wmove(userwin, cursor_place, 0);
			   user_show(usrname[user_place], user_place, nusers);
			   break;
			}
			else
				break;

		   }
		   case 13:
		   {
		     if(strcmp(usrname[user_place], "All Users"))
		     {
		 	rewind(log);
			
   			wmove(userborder, 14, 1);
 			whline(userborder, ACS_HLINE, 8);
			wrefresh(userborder);	
			wrefresh(userwin);
   			wmove(infoborder, 14, 1);
 			waddstr(infoborder, "<ACTIVE>");
			wrefresh(infoborder);	
			werase(infowin);
			n_lines = user_parse(log, usrname[user_place], month, 
					     &usr);
			for(i = 0; (i < 13) && (i < n_lines); i++)
			{
				wmove(infowin, i, 0);
				wprintw(infowin, "%s", usr.info[i+1]);	
			}
			wrefresh(infowin);
			info_win(n_lines, &usr, user_place);
		   	user_menu();
   			wmove(infoborder, 14, 1);
 			whline(infoborder, ACS_HLINE, 8);
			wrefresh(infoborder);	
 	   		wmove(userborder, 14, 1);
 	   		waddstr(userborder, "<ACTIVE>");
	   		wrefresh(userborder);	
		     }
		   break; 
		   }
		   case 'P':
		   case 'p':
		   {	
		     if(port_count)
		     {
   			wmove(userborder, 14, 1);
 			whline(userborder, ACS_HLINE, 8);
			wrefresh(userborder);	
			wrefresh(userwin);
   			wmove(portborder, 7, 1);
 			waddstr(portborder, "<ACTIVE>");
			wrefresh(portborder);	
		   	port_menu();
			p_win(port_count, onusr, onstr, 1);
   			wmove(portborder, 7, 1);
 			whline(portborder, ACS_HLINE, 8);
			wrefresh(portborder);	
 	   		wmove(userborder, 14, 1);
 	   		waddstr(userborder, "<ACTIVE>");
	   		wrefresh(userborder);	
		   	user_menu();
		     }
		     else
		     {
	  		ch = 0;
			msgwin=newwin(4, 25, 11, 25);
			box(msgwin, ACS_VLINE, ACS_HLINE);	
			wmove(msgwin, 1, 2);
			waddstr(msgwin, "No Active Ports");	
			wmove(msgwin, 2, 2);
			waddstr(msgwin, "Hit Any Key");	
			wrefresh(msgwin);
			while (!ch)
			{
			   ch = wgetch(msgwin);
			   if(ch)
				  break;
			}	
			werase(msgwin);
			wrefresh(msgwin);
			wrefresh(infowin);	
			delwin(msgwin);
		     }
		     break;
		   }
		   case 'f':
		   case 'F':
		   {
			findwin=newwin(4, 25, 11, 25);
			box(findwin, ACS_VLINE, ACS_HLINE);	
			wmove(findwin, 1, 2);
			waddstr(findwin, "Enter User to Find:");	
			wrefresh(findwin);
			wmove(findwin, 2, 2);
			echo();
			wgetnstr(findwin, find_name, 20);
			noecho();
			werase(findwin);	
			wrefresh(findwin);
			delwin(findwin);
			wmove(infowin, 0, 0);
			wrefresh(infowin);	
			found = 0;
			ch = 0;
			for(i = 0; i < nusers; i++)
			{
			  if(!strcmp(usrname[i], find_name))
		 	  {
		 		found = 1;
				cursor_place = 0;
				user_place = i;
			   	wattrset(userwin, A_NORMAL);
				wmove(userwin, 0, 0);
				werase(userwin);
				wrefresh(userwin);
				for(j=0; (j<nusers && j<13); j++)
				{
	   			   wmove(userwin, j, 0);
	   			   waddnstr(userwin, usrname[i+j], 9);
				}
				wmove(userwin, 0, 0);
			   	wattrset(userwin, A_REVERSE);
				waddnstr(userwin, usrname[user_place], 9);
			   	user_show(usrname[user_place], user_place,
						nusers);
				wrefresh(userwin);
			        break;
			    }
			}
			if (!found)
			{
			   msgwin=newwin(4, 25, 11, 25);
			   box(msgwin, ACS_VLINE, ACS_HLINE);	
			   wmove(msgwin, 1, 2);
			   waddstr(msgwin, "User Not Found");	
			   wmove(msgwin, 2, 2);
			   waddstr(msgwin, "Hit Any Key");	
			   wrefresh(msgwin);
			   while (!ch)
			   {
				ch = wgetch(msgwin);
				if(ch)
				  break;
			   }	
			   werase(msgwin);
			   wrefresh(msgwin);
			   wrefresh(infowin);	
			   delwin(msgwin);
			}
		   }
		}
	   }
	}
}

/*	The function w_win() is called once when the user information
	for global statistics is being found.
*/

void	w_win(char waitchar)
{
	box(waitwin, ACS_VLINE, ACS_HLINE);
	wmove(waitwin, 2, 4);
	wprintw(waitwin, "Retrieving User Statistics", waitchar);
	wmove(waitwin, 3, 4);
	wprintw(waitwin, "Please Wait %c", waitchar);
	wrefresh(waitwin);
}

/*	Erase all windows and return the screen to normal.
*/

void	clean_win()
{
	erase();
	endwin();

}
